	NEWS

Update History for Package 'lessR'
------------------------------------------------------------------------
------------------------------------------------------------------------
------------------------------------------------------------------------
 

 
 
>>>>>> Changes for lessR version 3.9.3 (2020-02-29) <<<<<<

-------------
Updates 3.9.3
-------------

ic
  new function that selects columns in a base R Extract subsetting

ir
  new function that selects rows in a base R Extract subsetting

pivot
  new function to create a pivot table based on base R aggregate

Merge, Sort, Transform
  listing of beginning of modified data frame dropped

Regression
  title added to Rmd output, avoids warning, moved from 1st level header

Sort
  data frame moved to first position in parameter list to facilitate
    pipe operator from magrittr package

ttest
  for brief output, within-group pooled standard deviation added

Note: bar chart vignette added


---------------
Bug Fixes 3.9.3
---------------  

BarChart
  for legend_position = "top", the top margin has more space

BarChart, SummaryStats
  a categorical variable with only one category now works

Sort
  names of sorted variables correctly appear on output


 
>>>>>> Changes for lessR version 3.9.2 (2020-02-10) <<<<<<

-------------
Updates 3.9.2
-------------

corEFA
  items within each factor sorted by loading
  items with factor loadings < 0.5 no longer separate from other items

corRead
  now can pass read.table() parameters such as sep="," for csv format
  var_names new name for names parameter

Logit
  prob_cut can be a vector, displaying multiple confusion matrices

Plot
  better arrangement of Trellis plots with by1 and by2 variables
  single variable plot with  by  converted to  by1, more meaningful
  1-D scatterplot identifies box plot outliers in red by default

Regression
  when k-fold > 0, only cross-validation results reported
   
simCImean, simCLT, simFlips, simMeans
  seed parameter added to set seed for reproducible results

simCLT
  default number of samples of data, n_display, changed to 0 from 2

simFlips
  line segments plotted in "gray40" instead of "coral3"


---------------
Bug Fixes 3.9.2
---------------  

BarChart
  when reading the value of Y, for the display of the values at the console,
    label according to the name of the variable instead of Count

corCFA
  properly display variable labels that have been read into data frame l

corEFA
  for display of factor loadings, columns line up with min_loading > 0

corRead
  if var_names not specified, default names X01, X02, ... properly assigned



 
>>>>>> Changes for lessR version 3.9.0 (2019-12-13) <<<<<<

-------------
Updates 3.9.0
-------------

BarChart
  values written to more bars if beside=TRUE

BarChart, Plot
  row names variable now row_names instead of row.names

BarChart, Histogram, Plot
  row parameter for filtering rows changed from rows to filter
  stat_x and stat_yx parameters merged into stat, old still work

Histogram
  default fill color of histogram, fill_hist, darkened a bit, from
    violin_fill to se_fill

Logit
  prob_cut probability threshold parameter added so default of 0.5
    can be changed for predicting (classifying) group membership
  in addition to accuracy, recall and precision fit indices added

Plot
  stat_x and stat_yx parameters merged into stat, old still work
  rm extended by 0.3 inches for by plots

Regression
  scatterplot matrix text display font size better optimized


---------------
Bug Fixes 3.9.0
--------------- 

Plot
  trellis dot plot works, for both "count" and "proportion"

Sort
  direction parameter works

tt_test
  correct variable listed on the horizontal axis for two-group plot
 
 

>>>>>> Changes for lessR version 3.8.9 (2019-08-25) <<<<<<

-------------
Updates 3.8.9
-------------

BarChart
  internal aggregation now with a by variable for raw data,
    not just pre-aggregated data, such as the mean of Salary
    over categorical variables Dept and Gender,
    BarChart(Dept, Salary, by=Gender, stat_yx="mean")

getColors
  palette "distinct" revised with a custom qualitative sequence of 20
    colors, of which the first five are from the default HCL
    qualitative sequence
  default hues palette changed from c=65, l=55 to c=60, l=50

Regression
  K-fold cross-validation option added with kfold parameter


---------------
Bug Fixes 3.8.9
--------------- 

Plot
  scatterplot with only two points can now be produced
  MD_cut now properly named, instead of deprecated MD.cut



 
>>>>>> Changes for lessR version 3.8.8 (2019-07-31) <<<<<<

-------------
Updates 3.8.8
-------------

BarChart
  error message added for when reading y directly as aggregate data and
    there is missing aggregate data in x, by, and/or y (otherwise 
    an indecipherable internal R error message)

factors
  deprecated name doFactors removed

Histogram
  parameter density added, if TRUE then density plot from Density
    presented, essentially obviating the need for a separate function
  other density parameters also added
  summary stats output added for density option

Density
  default for parameter type changed to "general", former default
   "both" for general and normal density continues to work if
   specified
  default fill colors of general and normal density curves switched 
  background histogram a little darker ("violin_fill")
  color of density curve a little lighter, "gray20" instead of "black"

Plot
  default fit line and ellipse fill changed to a dark blue from gray
  scatterplot matrix lettering made smaller
  add_trans parameter now only applies to fill

Regression
  Rmd_data parameter added to explicitly specify the path name of the
    data file to be read when running the generated R markdown file,
    otherwise rely upon the default, the last file read by Read


---------------
Bug Fixes 3.8.7
--------------- 

Density
  left margin room sized for longer density values on y-axis

Plot
 scatterplot matrix displays scatterplots when x specified as
   a vector of variables (as reg always did)
 more room for right margin for legend with longer variable names


 
>>>>>> Changes for lessR version 3.8.6 (2019-06-03) <<<<<<

-------------
Updates 3.8.6
-------------

BarChart
  data to console from reading values of Y displayed vertically
    if horizontal display does not fit within the width of the
    R console
  output to object: n.dim, n.miss, freq.df changed to n_dim, n_miss, freq
  ordered by variable also default triggers sequential palette

Read
  reading units in a variable labels files now done with 
    var_labels=TRUE, reading into a separate label file l
  rd.lbl() function added to abbreviate for var_labels=TRUE
  if no format specified and no valid filetype specified, presume
    a built-in lessR data file, e.g., Read("Employee")
  in_lessR parameter removed as no longer needed

Regression
  variable labels/units now must be read into a separate
    label file named l to apply to generated R markdown
  scatterplot of a single predictor with response variable now a 
    bubble plot of counts if less than 10 responses on x-variable


---------------
Bug Fixes 3.8.6
--------------- 

BarChart
  bar_fill in style now detected and applied

Density
  missing data works if not specifying bin_start

Regression
  html file format is properly the default rendering format for
    the Rmd option
  if label file read after data file, original data file properly 
    referenced in knitting of markdown file
 

 
>>>>>> Changes for lessR version 3.8.5 (2019-05-16) <<<<<<

-------------
Updates 3.8.5
-------------

BarChart
  updated legend spacing to accommodate larger labels

Plot
  correlation analysis now done for line charts with points
  plotted label size for points now has smaller default

Regression
  X1.new, etc. parameters now work for reg_brief()
  scatterplot of a single X with Y now has points that are similar
    in aesthetics to those from a Plot() scatterplot


---------------
Bug Fixes 3.8.5
--------------- 

BarChart
  fixed bug introduced in 3.8.4 that prevented legend from displaying

Plot
  fixed crash in Plot regarding assignment of NULL to an output chunk

Regression
  html file format is properly the default rendering format for
    the Rmd option
  if label file read after data file, original data file properly 
    reference in knitting of markdown file


 
 
>>>>>> Changes for lessR version 3.8.4 (2019-04-25) <<<<<<

-------------
Updates 3.8.4
-------------

all data analysis functions
  period in parameter names deprecated, replaced with _

BarChart
  for consistency, parameter addtop deprecated, changed to add_top

getColors
  removed the random color option with function distinct from
    the randomcoloR package because one of its dependent
    packages, V8, would sometimes not properly install

Regression
  R markdown file now can be rendered into multiple formats
  R markdown file additional formats available: odt and rtf

Plot
  scale.x and scale.y parameters added for control of the numerical
    values of the respective axis: start value, end value, n increments
  fit line possible now for run charts

Read
  leading dots (periods) if present removed from beginning of
    variable names

ttest
  minimum default number of digits in summary statistics now 3
    to provide less rounding error in hand computations


---------------
Bug Fixes 3.8.4
--------------- 


 
>>>>>> Changes for lessR version 3.8.2 (2019-03-28) <<<<<<

-------------
Updates 3.8.2
-------------

data
  dataStockPrice.rda data updated through January of 2019

BarChart
  break.x now defaults to FALSE for horizontal bar chart, that is,
    do not break value labels at blanks by default
  break.x, break value labels to new line at a space, default
    only when not horizontal and rotate.x=0 
  stat.y parameter added to plot the "mean", "sd", "dev", etc. of
    y for each level of x, with default of "mean" for raw data table
  bar chart now possible with unique values of x
  row.names a valid variable name for x
  if analyze one variable of unique values, analysis proceeds by
    listing the values, instead of throwing an error message
  stack100 replaces prop, which no longer works but gives message
  fill=(count.v) for viridis palette of mapping y to fill

getColors
  power parameter added to allow customization for sequential and
    divergent scales (relying upon package colorspace functions)

Histogram
  prop parameter changed to stat.x="proportion" for consistency

Plot
  for Cleveland dot plot with two variables plotted against categorical,
    differences for each row of data displayed at the console
  annotations for a time series with dates on the x-axis now possible
    with passing x-coordinates as type Date
  for line plots, replace area=TRUE to get default fill color
    with fill="on"
  new area.fill parameter allows custom fill color
  Cleveland dot plot for counts now has axis that begins at 0
  stat.x parameter has "%" option to display percentages by level of x
  stat.yx parameter has "dev" option to plot mean deviations
  legend for two x-variables now vertical, just like two y-variables
  y-axis label plots by default even for Cleveland dot plot
  legend box color set to "transparent"
  stacked time series yields black lines of width=1
  Trellis time series by default n.col=1 if 4 or less panels, else is 2

Read
  automatically convert Excel date fields to R Date type (i.e., set
    openxlsx read.xlsx function parameter detectDates to TRUE)
  name of first parameter, the input file, changed from ref to from
  var.labels parameter replaces labels, set to TRUE if reading labels
  l replaces data frame name mylabels for reading variable labels

Regression
  quiet option provided
  automatic rendering of Rmd file
  if rendered Rmd output is html, automatically open in a browser
  Rmd.format parameter added for html, word, or pdf rendering

ttest
  rows option for selecting rows of data

Write
  name of first parameter, the output file, changed from ref to to
  Excel.table parameter added, default is FALSE for no table
  ExcelColWidth option added, set to FALSE to save time for large files
  if row names are consecutive integers, by default not written
  wrt.x abbreviation for format="Excel"


---------------
Bug Fixes 3.8.2
---------------  

BarChart
  axis labels for bar chart with values of y read (not tabulated)
    no longer reversed
 
Plot
  Cleveland dot plot of a vector of two or more numerical variables
    against a categorical variable displays correctly
  run=TRUE works if missing data
  Trellis dot chart shows proportions if requested
  color range such as "blues" and trans > 0 works

style
  style("gray") followed by a call to style with no theme and
    non-gray attributes now allowed
  pt.fill properly set

SummaryStats
  allow old default name mydata to work in place of new name d


 
>>>>>> Changes for lessR version 3.8.1 (2019-01-10) <<<<<<

-------------
Updates 3.8.1
-------------

Histogram, Plot
  cumulate new name for old parameter name cumul, which still works


---------------
Bug Fixes 3.8.1
---------------  

all data analysis routines
  adjustment to change in class of tibbles to recognize
    and internally convert to data frames
  properly use mydata as default if new default d not specified


 
>>>>>> Changes for lessR version 3.8.0 (2019-01-02) <<<<<<

-------------
Updates 3.8.0
-------------

all data analysis routines
  d is new name for default data frame, deprecated mydata still works
 
BarChart
  for 100% bar chart, chi-square test displayed right after two-way
    frequency table it assesses, before column proportions
  proportions on y-axis print with two digits consistently
  legend adjusts in size according to the size of x-axis values
  box around legend removed
  values.position new name for values.pos, which still works
  legend.size new parameter for size of legend text

Correlation
  fill.low and fill.hi parameters added for a custom sequential
    palette for a heat map
  output correlation matrix named R instead of cors
  heat.map new name for graphics because only heat.map generated

corReorder
  diagonal.new option added for diagonal of matrix to be replaced
    with average value of item on the diagonal with adjacent item
  n.clusters parameter added to get cluster membership for
    specified number of clusters for hierarchical cluster solution
  new parameter order specifies ordering procedure of retained
    correlations
  hierarchical cluster analysis new ordering technique and default
 
Correlation, corReflect, corCFA, corProp, corReflect
  correlation heat map now with divergent scales except for "grays",
    which is sequential from "white" to "black"
  axis.cex controls size of axis labels

Density
  for consistency, color.gen and color.nrm new names for gen.color
    and nrm.color
  rug new name for parameter band to better describe the option
  if indicated gray scale, can still customize non-gray colors
  added parameters color.rug and size.rug

factors
  new name for deprecated name doFactors, create multiple factors

Plot
  default size for bubble plot set to power=0.5, that is the 
   value of size that maps into the area so that a size of 0 maps
   to 0, before was close, old value of power was 0.6 
  smooth.exp the more descriptive name for smooth.trans
  scatterplot matrices with reg line now have CI about line

style
  values.size new name for deprecated name values.cex


---------------
Bug Fixes 3.8.0
--------------- 

all analysis functions
  prior search for data frames in the global environment was
    too broad, going into sub-objects, now properly restrictive

BarChart
  when not in default "colors" theme, two variable bar chart
    properly displays two colors
  title of horizontal legend correct
  location of top legend plots correctly
  non-factor by variables more consistently processed
  by1 option works consistently

Plot
  when size is a variable, correct labeling of min and max
    bubble sizes
  Bubble Plot Frequency Matrix works

ttest
  two-group pdf.file properly created when requested

Write
  Excel format works for any name of input file, not just the
    default name d (or old mydata)


 
 
>>>>>> Changes for lessR version 3.7.9 (2018-12-10) <<<<<<

-------------
Updates 3.7.9
-------------
 
BarChart, Histogram, Plot
  theme parameter added to change theme just for current analysis

BarChart, Histogram
  saved output to an object, e.g., h <- hs(Salary), now
    consistent with documentation and revised with more information

BarChart, PieChart
  an ordered factor plotted with a pre-defined sequential color
    palette by default, such as "blues", according to the color theme
  values.cex renamed values.size

BarChart
  fill color can be mapped for the value of the categorical variable,
    usually y when given, or refer to (count) when y is tabulated
  fill.split parameter added to display fill in two colors if
    above or below the value
  missing data for category with y given now allowed, plots as <NA>
        
BoxPlot
  fill parameter sent to Plot as box.fill

getColors
  qualitative color palette named "hues" instead of "colors"
  default for shape="wheel" is in.order=TRUE
  added viridis color palettes: "viridis", "cividis", "magma",
    "inferno", and "plasma"
  palettes from the wesanderson package added
  generate palettes of distinct random colors with the
    distinctColorPalette function from randomcoloR package,
    reference as "random"

Plot
  violin.fill and box.fill parameters added
  for VBS plot, vbs.pt.fill now applies to any specified color
  color ranges such as "blues" now apply
  by variable that is an ordered factor, levels "blues", etc
    is default according to the current color theme
  parameter named values renamed topic to avoid BarChart conflict
    of parameter also named values
  for legend in multi-variable plots on an axis with large axis.x.cex,
    legend text changed to be 0.83 * axis.x.cex
  smooth.size parameter added for size of plotted points in smoothed
    scatterplots
  for size a continuous variable, radius set to 0.1 instead of 0.25
  for plotting categorical variables, radius set to 0.22
  smooth.trans default changed from 0.20 to 0.25
  for VBS plot of discrete variable, display freq dist if requested
  bw.iter parameter added for use control of bandwidth iterations
  pl abbreviation for Plot

prob,norm, prob.tcut, prob.znorm
  pdf.file option, graphics output window consistent with other functions
  axis.size is new parameter name for mag (not applicable to prob.tcut)

Regression
  Rmd file better reflects parameter settings of explain, interpret, etc.

showPalettes
  new function to show all the palettes in a set, includes the
    hcl colors, viridis palettes and wesanderson palettes

style
  sub-theme no.y.axis improved

ttest
  mu is new name for mu0 parameter, which still works
 
ViolinPlot
  fill parameter sent to Plot as violin.fill


---------------
Bug Fixes 3.7.9
--------------- 

BarChart, Histogram, Plot etc
  fill parameter can now be set to a color function such as hcl
    or a named vector
  label size change (lab.x.cex, lab.y.cex) properly changed in 
    Trellis graphics, that is, with by1 and by2
  beside=TRUE plots correct color sequence

BarChart
  default values for y-provided analysis (instead of tabulated
    counts) is "input" instead of "%", which is not meaningful
    in this context
  values properly displayed for y-provided analysis
  quiet=TRUE works for Trellis graphics, by1 and by2

doFactors
  levels now required unless adding variable labels but not
    creating one or more factors

Plot
  Default of row names now properly label outliers in a box plot
  ID variable for labeling points beyond just default of row names
  for grayscale Trellis plots, points plot in grayscale

Read
  characters "(" and ")" now can be in a variable name that is parsed
    for invalid characters

Regression
  Rmd file generated if interpret=FALSE
  Rmd file knit under all combinations of explain, interpret, etc.

style
  "gray" theme with "black" sub.theme displays correctly



 
>>>>>> Changes for lessR version 3.7.6 (2018-08-10) <<<<<<

-------------
Updates 3.7.6
-------------

all analysis functions
  each variable in a vector of x-variables are checked to 
    actually exist in the specified data frame
  rows parameter added to provide for subsetting the input data
    frame by rows
  xlab.adj and ylab.adj replaced with a vector, lab.adj
  tm.adj, rm.adj, bm.adj, lm.adj replaced with a vector, margin.adj
  more complete display of axis lines
  fine-tuning of left and bottom margins

BarChart
  multiple x-variables with a common response scale such as a set
    of items with responses on a common Likert scale, are plotted
    on the same panel, many bar graphs combined into one
  more room added to the top of the plot when values.pos="out" to
    provide enough room to accommodate the added label
  values displayed on the bars with a by variable and beside=TRUE
  more room for legend for longer titles and value labels
  small values not displayed in the bars, controlled by values.
  sort.x values changed from "off", "down", "up" to "0", "-", "+"
  properly processes tibble files from the tidyverse

details
  ordinal position of each variable now listed (also with Read)
  
doFactors
  new function that converts one or more variables in a
    data frame to factors either as replacements or new variables,
    where the variables are specified as names: one name, a vector
    of sequential range of names from the data frame, or any
    arbitrary vector of names

getColors
  more pre-defined color names added so that now there is a name for
    each 30 degrees of the HCL color wheel: 
    "reds", "rusts", "browns", "olives", "greens", "emeralds",
    "turquoises", "aquas", "blues", "purples","violets", "magentas"
    + "grays" + "hues" for a qualitative sequence
  pre-defined color names such as "blues" define a divergent color
    palette by specifying a vector of two such names, applicable to
    visualization functions as an argument to the fill parameter
  sequential color palettes created with lightness of colors closer
    to each other the smaller number of colors generated
  trans options or transparency

Histogram
  properly processes tibble files from the tidyverse

Plot
  for gray theme, grayscale applied to multiple line plots
  color can be set to a sequential color range such as "blues"
  fit="ls" changed to fit="lm", former still works
  fit.se default changed from 0 to 0.95, so now shows by default
  se.fill a little darker with no border lines
    
Read
  empty character string option added to browse for file, Read(""), 
    more consistent with specifying a name than Read(), which still works
  when in RStudio added a warning added for browsing with rd("")
    that the browsing window is obscured behind the RStudio window
  in.lessR parameter added in place of deprecated format="lessR"
  when in RStudio, lists the data table in the Source window
 
style
  new default color theme is "hues", which yields discrete HCL colors 
    of different hues for bar/pie charts, and no longer a sub.theme


---------------
Bug Fixes 3.7.6
--------------- 

BarChart, Histogram
  for printing multiple variables, erroneous "no categorical
    variables" not displayed
  color ranges such as "hues" can be used for Trellis plots

margins
  axis label set to empty character string, "", now treated as NULL
    instead of occupying space as if there were a label
  
PieChart
  now properly generates a gray scale fill pattern when requested

Plot
  entered colors applied to line plots
  date axis annotations proper size instead of too large
  BPFM bottom margin corrected when value labels are rotated
  
style
  margins adjusted for better placement with large axis labels


  
  
>>>>>> Changes for lessR version 3.7.5 (2018-06-03) <<<<<<

-------------
Updates 3.7.5
-------------

style
  default lightbronze style changed with bar and point fill a slate gray
  for the themes with a white window and gray panel, such as "darkred",
    the default panel color is lightened from "gray95" to "gray98"
  new sub-theme "colors" which adds a progressive color gradient for
    histograms consistent with the current theme, hcl colors for bar
    and pie charts, no borders, and displayed values for bar and pie
    charts written in white inside the bar or slice of the pie

BarChart, Histogram, PieChart, Plot
  no.eval parameter added to force not evaluating for missing data frame
    and misspecified variable to allow to run in Shiny, set by default
    to TRUE for a Shiny analysis when the Shiny package is loaded

BarChart, Histogram, Plot
  manual adjustment of margins and axis label placement possible with
    new parameters: xlab.adj, ylab.adj, bm.adj, lm.adj, tm.adj, rm.adj
  scale.x and scale.y parameters allow custom specification of numerical
    axis values 

BarChart
  better margin computations with parameters added for manual adjustment
  sort.x parameter for decreasing sort of x for 1 and 2 variables
  labels.max option that can invoke abbreviation of value labels now
    provides a table that lists both abbreviated and full value label
  out.size options now added to specify the number of columns that the
    frequency distribution can take up before displayed as vertical
  for one variable analysis, n of missing data reported in text output
  similar to PieChart, values now can be displayed within the bars
  for managing large category values, which are displayed as axis
    labels, use an underscore, _, to indicate to not place a new line
    symbol in place of the space, which is then displayed as a space
    on the corresponding axis label
  data frame of frequencies also returned for two-variables if output
    assigned to a named R object
  variable labels as axis labels now not reduced in size if too long,
    instead uses as many lines as needed at current cex size 
  rotate.x=90, perpendicular x-axis labels, more aesthetic with no
    size limitation
  text output in a column if width does not fit into current console width
  pdf.file parameter now called pdf as it is TRUE or FALSE

getColors
  color sequence can be generated for any specified hue, h, from 0 to 360
  more pre-specified color sequence names such as "browns", "olives"
  pre-specified color sequences can be modified according to
    chroma, c, and luminance, l
  rectangular display option added as the default, wheel an option 
  control of the content and size of the plot title provided
  default border color from black to lightgray
  output parameter added to force text and graphics output on or off

Histogram
  for consistency with BarChart and PieChart for the display of the values
    for a bar, the parameter hist.counts changed to values

Plot
  rotate.x, rotate.y, offset added back so can set locally as well
    with the style function


---------------
Bug Fixes 3.7.5
--------------- 

style
  vertical and horizontal grid lines now properly aligned

BarChart
  axis.y.text.color now properly affects the display of the numerical axis

LineChart
  y-axis label prints for lc(), that is, multiple plots

Plot
  if boxplot only requested (vbs.plot="b"), scatterplot now not displayed

Read
  properly reads Excel label files from the Read function

label
  properly returns the label when used in non-lessR functions

labels (for all plotting functions)
  if label missing for a variable, then ignored instead of show as NA
  


  
>>>>>> Changes for lessR version 3.7.2 (2018-03-30) <<<<<<

-------------
Updates 3.7.2
-------------

BarChart, Density, Histogram, LineChart, Plot, SummaryStats
  specify data parameter forces variable from specified data table

BarChart
  statistics for each group printed for by1 variable
  fill, color and trans parameters restored, which correspond to
    style function bar.fill, bar.color and trans.bar.fill
  all non-default colors provided by restored fill parameter, perhaps
    with lessR function getColors, so colors parameter removed
  annotation option added

Histogram
  fill, color and trans parameters restored, which correspond to
    style function bar.fill, bar.color and trans.bar.fill
  annotation option added

PieChart
  numerical results -- percents, proportions or counts -- can be
    displayed either inside the pie chart or added to the labels with
    a variety of options for inside the pie that govern their display
  fill, color and trans parameters restored, which correspond to
    style function bar.fill, bar.color and trans.bar.fill
  cex is a general scaling factor for all displayed text: main.cex,
    values.cex and label.cex
  default color scheme for default theme, lightbronze, is now hcl, the
    scale of discrete hcl colors with constant chroma and luminosity
  lwd for line width parameter added for borders
  annotation option added
  generated colors available in output, invisibly returned

Plot
  fill, color and trans parameters restored, which correspond to
    style function bar.fill, bar.color and trans.bar.fill
  statistics for each group printed for by1 variable

Read
  Excel files now read with Alexander Walker's openxlsx package,
    which also allows to read Excel files directly from the web
  R type numeric, an ambiguous term, now referred to as R type double

getColors (old name: showWheel)
  rgb color approximation also displayed for each requested hcl color
  especially to display many colors, options to turn off border between
    slices and labels
  larger color wheel within confines of plot space
  quiet option added to suppress console output
  discrete HCL scale now re-ordered by default to obtain maximum
    adjacent separation for 24 or fewer colors
  continuous color gradation from setting clr and end.clr
  pre-specified color ranges added: blues, reds and greens

ScatterPlot
  now a convenience function instead of an equivalence to Plot,
    just calls Plot with vbs.plot="s" 

ttest
  xlab option added for custom specification of x-axis label,
    also now does the variable label by default if present

Write
  format="Excel" option added to write an Excel data table into an
    Excel worksheet with Alexander Walker's openxlsx package
  row.names option added explicitly to provide the same parameter
    to the different internal write function calls

ViolinPlot
  convenience function, just calls Plot with vbs.plot="v"


---------------
Bug Fixes 3.7.2
--------------- 

BarChart
  If a bar chart plotted for each categorical variable of the data table
    with bc(), no longer crashes if no categorical variables
  For y read directly (instead of tabulated counts), when both x and y-axis
    are given x need not be sorted alphabetically
  Grid lines properly display for horizontal plot
  trans.bar.fill from style function now properly sets bar 

Histogram, LineChart, Plot
  axes color from style apply correctly

Read
  Excel read works with labels in the second row

Plot
  time series axis labels color can be modified

Regression
  Color of a fit line in scatterplot matrix according to fit.color works

VariableLabels
  reading labels from an Excel file works



  
>>>>>> Changes for lessR version 3.7.0 (2018-01-06) <<<<<<

-------------
Updates 3.7.0
-------------

BarChart
  value labels more efficiently partitioned into separate lines
  y-label moved in a bit for horz=TRUE and mult-line label

BoxPlot
  function call restored, calls Plot(..., vbs.plot="b")

Details
  details.brief shortened to db

Plot
  parameter values only displayed if corresponding plot selected,
    e.g., no bandwidth (bw) if no violin plot, vbs.plot="bs" 

Read
  stringsAsFactors=FALSE, that is, character string variables read
    as type character instead of type factor
  labels parameter deprecated as labels now stored in mylabels

VariableLabels
  creates or modifies existing data frame of variable labels distinct 
    from the data frame of the data, save labels in mylabels data frame


---------------
Bug Fixes 3.7.0
--------------- 

BarChart
  prop works for y (numerical value to plot) directly specified
  decimal digits set to 3 for prop, fields fit better

Density
  missing data now automatically removed

Regression
  dummy variables work

Sort
  can sort character variables



  
>>>>>> Changes for lessR version 3.6.7 (2017-12-10) <<<<<<

-------------
Updates 3.6.7
-------------

BarChart
  added a returned data frame of the frequency table
  
BoxPlot
  deprecated with message to use Plot instead

PieChart
  doughnut or ring chart capability added and is now the default
  all the options from R function pie now included, such as density
  option to read y-variable directly, the numeric variable to plot
  y can can integer or real valued
  
Plot
  x-axis label adjusted slightly upward
  
showWheel
  further refined
 

---------------
Bug Fixes 3.6.7
--------------- 

in Debian and some other versions of Linux, regression mark-up file for
  interpretation crashed, now fixed


  
>>>>>> Changes for lessR version 3.6.6 (2017-09-08) <<<<<<

-------------
Updates 3.6.6
-------------

Plot
  add = "labels" to plot labels for the points
  confidence level for best-fit line specified directly, e.g., 0.95, instead
    of the number of standard errors
  left margin and bottom margin slightly reduced to increase plot size
  for Trellis and VBS plots, i.e., via lattice, axis.color settings override
    panel.color because they are otherwise the same setting in lattice
  
showWheel
  new hcl color wheel function, also allows manual entry of colors
  
style
  get=TRUE option added, as a placeholder to get the current theme settings
    without making any changes
  no.y.axis sub.theme now extends the panel.fill to window.fill as well
  style setting show=TRUE shows color names when applicable instead of
    rgb values and NULL instead of blank
 

---------------
Bug Fixes 3.6.6
--------------- 

BarChart
  scaling of axis label works

Plot
  for grayscale, outliers in black instead of gray to better view

Style
  saving and then re-reading style parameters works consistently
  se.fill works





>>>>>> Changes for lessR version 3.6.5 (2017-08-06) <<<<<<

-------------
Updates 3.6.5
-------------

Density
  automatically smooth the density plot, or manually specify bandwidth (bw)

Plot
  upgraded the boxplot option to a Violin plot with an enclosed Box plot
    and Scatterplot called a VBS plot
  VBS plot can be applied to conditioned variables by1 and by2 to provide
    multiple panels
  VBS plot can be applied to grouping variable by, multiple plots on 1 panel
  box.mean option added for the boxplot as part of a VBS plot
  outlier identification for boxplot can optionally be based on the medcouple skew
    index and box plot adjustment added for box plot in VBS plots 
  outliers in a boxplot labeled on the plot and identified in console output
  if outliers labeled according to ID.cut, labeled points plotted with out.fill
  out.cut to identify outliers can be specified as either a proportion or as a count
  display inner fences that determine the outliers when fences=TRUE
  2-D scatterplot: if outliers labeled according to ID.cut, and a fit line
   indicated, then a second (dashed) fit line is calculated without outliers
   and displayed
  2-D scatterplot: MD.cut added to identify outliers by Mahalanobis Distance
  changed the meaning of n.cat, default now 0, so default is that equally
    spaced integer values represent measurements of a continuous variable,
     bubble plot for two variables follows now from repetitions of data values
  smooth option for large datasets uses window.fill to color plot background
  . is a valid shape
  auto=TRUE adds much information to the two-variable scatterplot
  
Regression
  scatterplot matrix aesthetics improved, including larger typeface for
    the correlation coefficients
    
style
  all parameter values can be saved as a list, e.g., p <- style("gold")
  the set parameter allows previously saved list to read back into style
  many more controls of graphics parameters added


---------------
Bug Fixes 3.6.5
--------------- 

Plot
  outlier point specification of a letter, digit or punctuation works
  provided list of bright discrete colors now has each color unique
  
Regression
  suggestion for .Rmd file properly references reg instead of reg.brief

ttest
  y-axis for paired differences graph labeled correctly
  
  
  

>>>>>> Changes for lessR version 3.6.2 (2017-05-13) <<<<<<

-------------
Updates 3.6.2 
-------------

BarChart, Density, Histogram, LineChart, Plot
  all parameters to specify color are now specified, for a given object, as
    object.fill or object.stroke, except that fill and stroke by themselves
    refer to the primary object, a bar or a point
  slightly increased the intensity of the colors for different discrete levels

BarChart
  Trellis graphics added with by1 as the conditioning variable
  cex.names option added to specify size of labels for the categories
  cex.lab option added to specify size of axis labels
  for horizontal chart, scaling of value labels consistent
  over.plot option eliminated

Histogram
  rotate.x, rotate.y and axes extended to Trellis graphics
  grid lines added to Trellis graphics
  over.plot option eliminated
  
Plot
  categorical x-variable, value="count" ...
    a. if by1 set, then a Trellis dot plot
    b. single panel dot plot horizontal to match dot plot style
  fill.ellipse, stroke.ellipse, stroke.fit, ... changed to 
    ellipse.fit, ellipse.stroke, fit.stroke, ...
  cex.lab option added for regular and lattice plots
  bubble.fill option added
  ID labels for extreme points active for smoothed plots
  
style
  re-setting the theme resets all parameter values, setting sub.theme and
    individual values cumulates the changes without resetting
  when setting a global theme, can now specify fill and stroke generally,
    to set both fill.bar and fill.pt, and stroke.bar and stroke.pt
  theme replaces colors as the name of the option that specifies the color theme
  cex.axis, axis.stroke, rotate.x, rotate.y, offset added to style
  device.fill, grid.lwd, grid.lty, bg.lwd, bg.lty added to style
  black themes fill the entire device window with black using device.fill
  darkgreen theme added
  ghost option invoked now with style(sub.theme="black")
  gray.dark theme replaced with style("gray", sub.theme="black")
  sub.themes added, which changes the plot style as well as colors


---------------
Bug Fixes 3.6.2
--------------- 

BarChart
  if reading values direct with y-var, x-axis label now provided
  
Histogram
  custom y-axis label does not add variable name to the end of the label
  
Plot
  means for categorical-continuous plot now printed if for a non-factor
    categorical variable (i.e., a small number of integer values)
  time series from global plots even if no d data frame exists
 



>>>>>> Changes for lessR version 3.6.0 (2017-03-30) <<<<<<

-------------
Updates 3.6.0
-------------

BarChart
  y parameter added to allow a bar chart of any y-variable with new
    parameter order -- x, y, by -- so by must now be explicitly indicated
    to specify a by variable

BarChart, Histogram
  trans option added to set trans.fill.bar

Histogram
  Trellis graphics activated with a new by variable, plus new by2 variable
    for all cross-classifications of the levels of two conditioned variables  

Plot
  Trellis graphics activated with the by variable, plus new by2 variable for
    Trellis graphics for all cross-classifications of the levels of two
    conditioned variables
  new by.group parameter to activate all scatterplots for levels of a third
    variable on the same plot, which if applied to Trellis plots activated
    with by, is a grouping variable with multiple plots on the same panel
  the number of specified ellipses per by.group 
  add and related parameters for annotating a plot
  ID, ID.cut, ID.size, ID.color added to label plotted points
  time series data with dates in the x-column can be formatted as tidy data, with 
    the values all in one column, in addition to wide data
  scatterplot matrix from a vector of continuous variables
  trans parameter applies to area
  mean added to 1-D scatterplot
  plot with two run charts has dotted line for second plot to maintain color theme
  lwd.fit parameter added for line width of the fit line
  radius, power, size.cut replace bubble.scale, bubble.power, bubble.text
  rotate parameter morphed into rotate.x and rotate.y
  do.plot added so can turn off the plot and only have the stat analysis
  add and related parameters for drawing objects, text or figures, on the plot
  
Read
  labels="row2" option revised to skip the third row of the data table,
    in accordance with the new Qualtrics download format that has
    added a third row to the data table that is not data
  
Regression
  following Plot function, a scatterplot of x,y a bubble plot for
    variables with a small number of integers
  improved formatting of scatterplot matrix, least squares fit line
  for integer input, number of digits in output is now 3 instead of 2
    
global
  new name for theme function, theme deprecated to avoid ggplot2 conflict
  trans option added to simultaneously specify both trans.fill.pt
    and trans.fill.bar
  

---------------
Bug Fixes 3.6.0
---------------

BarChart
  1-variable matrix input with no provided label for x-axis works
  
Histogram
  if no histograms produced with hs(), program does not crash
  
Plot
  the region specified by an ellipse could truncate points with large
    x-value or y-values from the plot, now fixed
  if dark background set locally without changing theme, legend
    lettering properly displays a light color
  for a frequency polygon, quiet=TRUE works correctly
  for prop=TRUE and categorical, the proportions display correctly

SummaryStats
  in stand-alone R, outside of RStudio, graphics window does not open


  


>>>>>> Changes for lessR version 3.5.5 (2017-02-08) <<<<<<

-------------
Updates 3.5.5
-------------

ANOVA, Histogram, Plot, Regression, ttest
  updated to work with tibble data frames obtained from RStudio import

BarChart, BoxPlot, Density, Histogram, LineChart, Plot, Regression, ttest
  height and width replace pdf.height and pdf.width, and also apply
    to graphic windows in standard R environment
  fill, stroke, ... replace color.fill, color.stroke, ...
  
BarChart, BoxPlot, CountAll Density, Histogram
  pdf.name changed to pdf, TRUE or FALSE, with default output going to
    current graphics window for multiple plots such as with hs()

BarChart, Plot, SummaryStats
  label.max parameter added to abbreviate value labels
  
Plot
  multiple plots with dates when date specified as the x-variable
  multivariate time series can be the x-variable for multiple plots
  stack option for multiple time series / run charts
  standard error option for plotting fit lines, can be a vector
  segments option for line segment color customization
  stroke.fit.line name change and default is stroke.pt instead of gray
  removed bar=TRUE option, use full functionality in Histogram and BarChart

Regression, ttest
  when running in R and not RStudio, graphs default to 5 x 5 inches

theme
  all non-black color themes have the same light gray background
    and white grid lines
  new brown and darkred color themes
  

---------------
Bug Fixes 3.5.5
---------------

Density
  now works with quiet=TRUE

Read
  variables with missing names are eliminated instead of crashing

SummaryStats
  output values freq and prop accessible as numeric tables



>>>>>> Changes for lessR version 3.5.3 (2017-01-01) <<<<<<

-------------
Updates 3.5.3
-------------
  
corCFA (cfa)
  RMSE added as a fit index
  
Density, Histogram, Plot
  outlier analysis (for Plot, the single continuous variable analysis)

Plot
  boxplot option added for 1-variable scatterplot
  outlier analysis added to Cleveland dot plot
  suggestions to obtain related plots enhanced
  bubble plot frequency matrix detects the response categories even if some 
    variables have zero frequencies in one or more categories
  sort option (sort.yx) for bubble plot frequency matrix
  object parameter dropped
    bar object set as a separate parameter
    line option controlled by line.width
    size=0 turns off display of points
  color.fill.ellipse now set according to current theme color
  line option for a run chart provides analysis of runs
  fit.line also applies to a time series
  color.area also applies to a time series
  color.area set to TRUE sets default to the point fill current color
  
  
Plot, LineChart, Histogram, BoxPlot, Density
  spacing of margins and axis labels enhanced and standardized
  
SummaryStats
  column names abbreviated with dictionary for more readable tables
  
theme
  color of color rose changed to rosybrown1, retain rose as its name
  
ttest
  density graph revised, including translucent fill colors


---------------
Bug Fixes 3.5.3
---------------

BarChart
  excessive left margin for some horizontal plots reduced

LineChart
  properly plots
  
Plot
  extra blank graph after each graph in RStudio eliminated
  grid lines extending past the figure boundary after a by chart fixed
  legend for multiple x or y variables displays when background is black
  bubble plot frequency matrix works without variable labels

Regression
  scatterplot with one categorical predictor variable plots levels correctly
  
  

>>>>>> Changes for lessR version 3.5.1 (2016-10-19) <<<<<<

-------------
Updates 3.5.1
-------------

Plot
  Cleveland dot plot displayed with segments.y and color.grid="off" as default
  2-D scatterplot smoothing option, smoothed, turned on by default for n>=5000
  for a line plot, input variable can be a time series
  speeded up the processing of bubble plots
  time series dates plot more generally and more cleanly
  

---------------
Bug Fixes 3.5.1
---------------

Plot
  if more than 2 x-variables, sort of y by x (sort.yx), which would not be 
    meaningful, causes an error and so is not attempted
  if no sort requested for Cleveland dot plot, no alphabetical ordering
  a requested color gradient in a bubble plot works for integer variables 
    as well as factors
  prop as a topic works in place of counts for bar charts and histograms
  multiple ellipses display when color.ellipse is specified

LineChart
  time series plots even if missing data



>>>>>> Changes for lessR version 3.5.0 (2016-08-29) <<<<<<

-------------
Updates 3.5.0
-------------

Density
  gray color theme now has a light-gray, transparent fill for the 
    general density curve, with the normal curve still no fill
  histogram option can be set to FALSE for no background histogram

Plot
  size option can be a variable, which triggers a bubble plot with the
    size of each bubble scaled according to the values of the variable size
  bubble.count option renamed to the more general bubble.text
  bubble.size option renamed to the more accurate bubble.scale
  when plotting two variables against a third with the gray color theme,
    both lines or sets of points retain gray scale

Read
  when detects an illegal character in a variable name, it is removed
    and the program continues 


---------------
Bug Fixes 3.5.0
---------------

ANOVA
  brief version, av.brief, works

BarChart
  col.bg may be set to "off" as intended

CountAll
  quiet applies to all output

Plot
  bubble plot for within column proportions available

Regression
  for a single predictor, confidence and predictor intervals properly plot




>>>>>> Changes for lessR version 3.4.8 (2016-05-01) <<<<<<

-------------
Updates 3.4.8
-------------

Graphics routines
  color.box option added at the global level with theme and locally,
    which provides for the border of the box around the plot
  set a color option to "off" sets it to "transparent"

ScatterPlot
  native RStudio scaling smaller than regular R, now adjusted
  multiple x-variables allowed for continuous variables in addition
    to categorical variables
  multiple y-variables allowed, but not both multiple x and y
  fit lines (loess or ls) for multiple variables
  argument for object named regular changed to the more
    descriptive name of point
  option name stat changed to topic, with a default of data
  options that started with the abbreviation col now start with color
  option sort.y renamed to sort.yx to be more descriptive
  option sort.yx sorts y by x for a single x-variable, and by x2-x1 for
    two x-variables
  option size renamed from the R notation cex for scaling factor of
    plotted symbol
  option object replaces more restrictive option type
  topic arguments include proportion, median, diff for difference
  row.names can given for the x-axis as well as the y-axis
  one or more continuous x-variables and no y-variable with a
    line object results in a run chart(s) with Index on the x axis
  segments.y for a Cleveland dot plot with two variables specifies
    to join each pair of points with a line segment
  diag option for diagonal line dropped because replaced with a
    Cleveland dot plot for two variables
  means are plotted for both categorical x and numeric y and vice versa
  suggestions often provided for alternate visualizations

theme
  suggest option added, which provides suggestions for additional input
    (currently implemented for ScatterPlot)

ttest
  confidence interval of standardized mean difference dropped because
    it relied upon the MBESS package, which added too many dependencies
  diagonal line plot replaced with two variable Cleveland dot plot


---------------
Bug Fixes 3.4.8
---------------

BarChart
  for small number of levels, bars again now scaled narrow

ScatterPlot
  line argument works for option object 




>>>>>> Changes for lessR version 3.4.6 (2016-03-27) <<<<<<

-------------
Updates 3.4.6
-------------

BarChart, ScatterPlot, SummaryStats
  a numeric variable with less than n.cat unique values considered
    categorical only for values that are all integer 

BarChart
  addtop is a multiplicative factor for expanding room between
    the highest bar and the top of the plot, instead of additive,
    also a little more space added by default for 1-variable plots
    by setting the default to 0.05 of total height
  addtop now provides a buffer also for horizontal graphs
  prop=TRUE for two variables provides column proportions instead
    of for rows
  for consistency, count.levels now referred to as count.labels

Read
  variable names are checked for invalid characters in text files
    and Excel files, which R does not do 

set
  re-named theme

SummaryStats, BarChart, ScatterPlot
  for 2 variable cross-tab analysis, if there is no p-value because
    the cross-tab table is not well-formed, such as too many 0's, 
    appropriately indicated in the output

ScatterPlot
  trans.fill option added to set trans.fill.pt in the function call,
    can still be set globally from function theme
  if y-values are unique, as in a Cleveland dot plot, default
    transparency level is 0 because no over-plotting, though can be
    set from trans.fill option also
  bubble.power option provides larger bubbles for smaller frequencies and
    allows the user to provide a custom value
  bubble plot applies also to numeric variables
  option kind renamed style
  "off" added as a value of style, that is, do not plot the data values
  stat option added to produce a scatter plot of statistics such as the
    mean of a continuous variable against levels of a categorical value,
    or counts of a categorical variable, instead of the original data
  sort.y added to sort y-values by x-values, for Cleveland dot plot
  when y is set to row.names, y becomes the row names of the data table
  segments.y and segments.x options for line segments from axis to points

theme
  new name for set
  for default gray theme, base color for point fill and stroke is darker


---------------
Bug Fixes 3.4.6
---------------

BarChart
  stats for two variables prop (proportion) option works
  beside=TRUE, values properly labeled on x-axis

ScatterPlot
  a factor with more levels than unique values displays properly
  large values of frequencies display properly
  by legend displays properly with black background colors
  extreme outlier points plotted with ellipse


>>>>>> Changes for lessR version 3.4.4 (2016-03-04) <<<<<<

-------------
Updates 3.4.4
-------------

Graphics general
  long variable labels printed on graphs with full text, made
    multi-line and also size shrunk if needed to fit
  xlab and ylab arguments also printed multi-line, size shrunk if needed
  variable name pre-pended to the displayed variable label
  default tick labels size reduced from 0.85 to 0.75, 
  white space at top of graph reduced if no title
  rotate.values and offset options provided to rotate axis values so as
    to provide more space for the label
  numerical axes value labels all displayed with same number of decimal digits

BarChart
  for two variables, prop=TRUE plots the row proportion cell frequencies,
    which are now also displayed in the text output
  value.labels option added to provide labels other than the existing values

LineChart
  individual runs not displayed by default, use show.runs to display

ScatterPlot
  can specify ellipse level including a vector of values to plot
    multiple ellipses on the same scatter plot
  allows bubble plot for two categorical variables in addition to the
    already categorical x variable, and both x and y numeric for 
    traditional scatter plot or small number of integer values for a
    bubble plot
  if bubble is large enough in a bubble plot, include the frequency
  displays a 1-D bubble plot for a single factor variable
  scatter plot of one variable more narrow and centered in plot window 
  introduces the Bubble Matrix Frequency Plot for Likert-type data in which
    multiple x-variables display a bubble plot of frequencies for the
    responses for multiple variables 
  bubble plot from small number of unique numeric values under user control
    as set with n.cat, default=10 unique values of a variable
  means plot with categorical x-axis, lines of means are darker, points 
    transparent, and the points for means are darker (or lighter)
  summary stats output of stat analysis for each type of scatter plot
  bubble plot displays corresponding counts, controlled by bubble.counts
  labels option added to provide labels other than the existing values for
    non-numeric variables
  fit.line can be set to TRUE without specifying a specific best-fit line,
    which provides a loess best-fit line
  value.labels option added to provide labels other than the existing values
  alternate names of DotPlot or dp for a 1-variable plot removed
  

Merge
  parameters from the R merge function can be passed through, such as all.x=TRUE

Read
  brief version of output now default, use details function to full version

Regression
  new name for the generated R markdown file is Rmd instead of knitr.file
  if data standardized, then so indicated on the output



---------------
Bug Fixes 3.4.4
---------------

BarChart
  when counts directly specified in a file, count.levels labels 
    correct variable name
  beside=TRUE now works for 2-variable plots
  prop=TRUE now works for 1-variable plots
  two global variables now correctly produce 2-variable plot

corCFA
  item content properly displays

Help
  superfluous graphics window no longer opens for Help(lessR)

Regression
  if no predictors are not significant at p<.05, analysis now proceeds
    to generate Rmd file
  the names of collinear variables now listed in output of Rmd file

ScatterPlot
  y variable now correctly re-defined according to n.cat when specified

ttestPower
  values correctly passed for plotting power curve




>>>>>> Changes for lessR version 3.4 (2015-12-27) <<<<<<

-----------
Updates 3.4
-----------

error trapping
  more development of lessR error trapping to replace the more cryptic
    R error messages with more understandable messages that also provide
    guidance as how to correct the problem
    of existing lessR explanations and the following additions:
    1. specifying variables to analyze that do not exist in the data table
    2. specifying variables to analyze without having a data table
    3. naming the intended default data table Mydata instead of d
    4. calling a data frame in place of a variable in ttest
    5. improperly enclosing a variable name in quotes in a function call
    6. failing to specify a variable to analyze in ttest and ScatterPlot
    7. trying a histogram for a categorical variable
    8. trying a scatter plot with the second variable non-numeric

BarChart
  colors changed for two variable plots, now based on hues generated by
    rainbow_hcl(24,c=38,l=75) from the colorspace package, such that
    when desaturated all colors have the same shade of gray
  proportions option now available for 2 variable plots
  phi coefficient or Cramer's V displayed with two variable analyses

PieChart
  frequency distribution added so that text output is same as BarChart
  colors same as BarChart for two variables

SummaryStats
  chi-square test provided
  phi coefficient or Cramer's V displayed with two variable analyses

Help
  spacing improved with shorter lines of output

Logistic
  collinearity analysis restored

Regression
  subsets option can be an integer to specify maximum number of lines
    displayed, where each line represents a specific subset model
  for subsets of more than 40 lines, the variable names are written
    each 30 lines
  scatter plot matrix adjusts the size of the correlation coefficients
    depending on the number of predictors
  better labeling of subsets output to indicate that only the best
    10 models of each number of predictors are considered, when relevant

Read, details
  More concise output
  Hadley Wickham's read_excel function restored for reading Excel files,
    and Read re-interprets the variable types from read_excel so that
    they are equivalent to those from reading other file formats with Read

ttest
  for paired analysis, difference score now computed from subtracting
    first variable from second variable

ScatterPlot
  ellipse option restored, with axes automatically reset to provide for 
    values of the ellipse that exceed the range of values of the data,
    and fill.ellipse color can be specified, usually with partial
    transparency such as rgb(.8,.8,.8,.2)
  correlation analysis restored
  if xy.ticks is FALSE, then axis labels moved closer to the plot
  ellipse option applies to bubble/sunflower plot

VariableLabels
  new function that essentially replaces label function, with new
    features of reading a file of variable names and labels separately
    from the Read function, and also from the console


-------------
Bug Fixes 3.4
-------------

BarChart
  legend printed in light text if background is dark

Histogram, SummaryStats
  outlier analysis for small outliers improved

Merge
  variable units now properly processed

ScatterPlot
  empty graphics window no longer generated

SummaryStats
  when number of unique values <= n.cat, properly treat variable
    as categorical

ttest
  missing data allowed for paired version



>>>>>> Changes for lessR version 3.3.6 (2015-11-05) <<<<<<

-------------
Updates 3.3.6
-------------

ANOVA
  output now constructed in segments for better knitr compatibility, 
    > a <- ANOVA( ... )
    > a   # view all the output
    > names(a)  # view the names of the segments 
    > a$out_anova  # for example, view the summary table
  knitr.file option for automatic construction of markup file
    from the various output segments
  improved formating of summary table
  graphics=FALSE option added


----------------------------
lessR Installation Bug Fixes
----------------------------
Read
  because of potential package dependency problems loading packages 
    with the readxl package function for reading Excel files, went
    back to the gdata package for reading Excel files, which requires
    Perl, which requires a download for Windows computers, and which,
    unfortunately only reads the formatted data not the actual data,
    so first format the Excel data according to the General format
    before reading

ScatterPlot
  because package dependency problems loading packages with the car
    package, the ellipse option from that package is deactivated

Regression
  because package dependency problems loading packages with the car
    package, the scatter.3D option from that package is deactivated


---------------
Bug Fixes 3.3.6
---------------

Regression
  background, which listed variables in the model, sample size, etc., 
    displays the intended information




>>>>>> Changes for lessR version 3.3.4 (2015-08-22) <<<<<<

-------------
Updates 3.3.4
-------------

Read, details
  better display format of variable labels and units

Regression
  knitr.file option has added display options code for displaying the
    code that generated the results and document for documenting the code 
  knitr.file option extended to work with d <- rd(), that is browse
    for the file to read before doing the regression
  improved use of variable units in R Markdown from knitr.file option

Set
  can set the values for display options globally in the generated
    knitr.file generation, which includes results, explanation,
    interpretation and document


---------------
Bug Fixes 3.3.4
---------------

ANOVA
  missing terms from the sums of squares table included

Histogram, Density and BoxPlot
  variable names that are also function names are properly processed

Merge, Subset
  variable units preserved

Read
  specified format of data file remains regardless of file type




>>>>>> Changes for lessR version 3.3.3 (2015-07-23) <<<<<<

-------------
Updates 3.3.3
-------------

Read
  Hadley Wickam's read_excel function used for reading excel files,
    which does not require Perl, with the character variables from
    read_excel set as factors as with reading other data formats,
    except for the following addition for all formats ...
  Non-numeric character strings with unique values read as class
    character instead of class factor

Regression
  extensive further development of the generated markup file from 
    the knitr.file option
  up to 6 predictor variables allowed for specifying new data,
    instead of just 5

Logit
  up to 6 predictor variables allowed for specifying new data,
    instead of just 5

corCFA
  knitr.file option
  option for lavaan style model specification, the same code runs
    both corCFA and lavaan
  min.cor and min.res options added for minimum respective value to be
    printed, to improve readability of correlation matrices
  output correlations omit the decimal point for more compact output
  correlations predicted from the model available in assigned
    output of function
  factor labels displayed on output correlation matrices

Label, Details
  print formatting of labels improved

Read
  SAS files are read

Write
  specify parameters in a more standard order:  ref, data, format


---------------
Bug Fixes 3.3.3
---------------

corRead
  abbreviated form rd.cor properly recognized




>>>>>> Changes for lessR version 3.3.1 (2015-04-27) <<<<<<

-------------
Updates 3.3.1
-------------

BoxPlot, Density, Histogram
  output generated with named pieces such as for knitr,
    plus knitr.file option

Regression
  knitr.file much further developed including reproducing the full function
    call to the Regression function where the knitr.file is created, and
    now includes flags for output control:  explain, interpret, results
  knitr information is now only written to a file, not to the 
    output object
  displayed prediction intervals always contain the smallest interval
    and the largest interval
  PRESS R-squared included in the default output
  minimum number of decimal digits on output changed from 3 to 2,
    e.g., integer input leads to 2 decimal digits by default (override
    with digits.d)
  spacing of tabled output condensed

Histogram
  improved formatting of displayed frequency distribution

BoxPlot
  default for add.points option is overstrike instead of stack

corEFA
  rotate="none" option replaces show.initial option, now deleted

Nest
  the specification of the full model, the 3rd argument, can be
    all the variables in the full model or now just the added 
    variables to the reduced model to define the full model

output control flags, in this order of presentation: explain, results, interpret 
  On by default, but each can be set within each procedure that generates a knitr
    file as well as a global option, such as options(explain=FALSE)  

---------------
Bug Fixes 3.3.1
---------------

library(lessR) added to knitr files from knitr.file option

SummaryStats
  outliers properly identified if smaller in value than 3

Correlation
  heat map for correlation matrix works more generally

Regression
  works with no predictor variables, e.g., reg(Y ~ 1)
  printed tables correctly display factor variables

SummaryStats
  if a by variable, now no output for stats in assigned object, instead of
    just for the last row





>>>>>> Changes for lessR version 3.3 (2015-03-19)} <<<<<<

-------------
Updates 3.3
-------------

knitr compatible

Regression, Histogram, SummaryStats
output system redesigned so that now all output is formally returned when
  the corresponding function completes, back to the standard R way of doing
  things in pieces, but here each piece is enhanced with additional features 

new function regPlot, which produces the Regression plots from the saved
  output of a previous regression run so that the plots can be interspersed
  throughout a knitr document

new function print.outall which, to add to knitr functionality, allows each
  of the pieces produced by Regression to be displayed individually, and is
  called implicitly by simply entering the name of the object
  
new function print.outpiece which, to add to knitr functionality, allows each
  of the paragraphs of output produced by Regression to be displayed individually,
  including in knitr, simply by entering the name of the saved piece, such as
  r$out_estimates if this was run: r <- Regression(Y ~ X1 + X2), and is
  called implicitly by simply entering the name of the object

Regression
  knitr.file option added to automatically generate knitr instructions which,
    when processed, result in an enhanced html, pdf or Word document that
    can be called interpretative output, statistical output plus commentary 
  graphics=FALSE option added, mostly for use with the new regPlot
  explain=TRUE now generates the explanation in the knitr instruction file
    instead of the console, and is now the default so reg.explain was removed
  all new components for the saved object, now of class out_all from the
    analysis instead of the object of class lm defined by the R lm function,
    though many components are shared, also includes the knitr instructions
  scatterplot matrix with correlations in the upper triangle now default
  

---------------
Bug Fixes 3.3
---------------

Screen size of subsequent plots not changed after Help()

SummaryStats
  for a by analysis, levels with n=0 do not prevent analysis of all levels

Correlation
  for a selected subset of variables, the heat matrix is plotted if requested




>>>>>> Changes for lessR version 3.2 (2015-02-24)} <<<<<<

-------------
Updates 3.2
-------------

if more than one plot is created from a function call the name of
  each plot is displayed at the end of the console output

RStudio compatible, when in RStudio now graphics are managed as a
  sequential stream to the plot window 


---------------
Bug Fixes 3.2
---------------

ttest
  line chart for a confidence interval of a mean displays (if requested)
    even if no hypothesized value
  for two groups, line.chart option works reliably for both groups

PieChart
 color gradient for ordered colors from an ordered factor extended to all
    color themes 

col.ticks parameter no longer defined by lessR functions but passed
    directly as an R parameter, which avoids the warning messages

warning messages
  the causes of many warning messages, though benign, were identified and
     removed by reprogramming




>>>>>> Changes for lessR version 3.1.1 (2014-09-22)} <<<<<<

-------------
Updates 3.1.1
-------------

corReorder
   provides a new cor matrix if specified

BarChart
  for gray scale, bars a little lighter shade of gray

corEFA
  lavaan code from the EFA solution revised

label
  no argument, label(), displays all variable names and labels

PieChart
  passing standard R graphics parameters produces a square chart, so to
    avoid this issue the magnification factors cex and cex.main, for
    the labels and title, are explicitly defined

ScatterPlot
  default 1-dimensional scatter plot is method="overplot"

ttest
  graph for one group extends to large deviant values of mu0 from the data
  brief version includes the margin of error
  includes needed sample size for desired margin of error for 1 and 2 groups

Write
  for a csv write, create a second file of any variable labels


---------------
Bug Fixes 3.1.1
---------------

label
  if the specified variable does not exist, an error message is displayed



>>>>>> Changes for lessR version 3.1 (2014-02-24)} <<<<<<

-------------
Updates 3.1
-------------

default color theme
  changed from "blue" to "dodgerblue", which now has 0.25 default
    transparency for bar fill, if the previous "blue" is desired,
    then set with: set(colors="blue")

citations
   use of functions from other contributed packages cited in output 

BarChart, BoxPlot, Histogram, ...
  can specify an entire data frame for analysis with the data parameter
    in addition to the variable parameter (x, usually listed first), 
    e.g., hs(attitude) or hs(data=attitude)

Density, LineChart
  analysis of a data frame or list of multiple variables possible

BarChart
  invisibly returns the frequencies and proportions just as SummaryStats 
    e.g., stats <- BarChart(Y), so stats contains this info
  pre-set transparency level of col.fill.bar applies to bar chart bars
    of a single variable

SummaryStats (and functions that call SummaryStats)
  outliers listed in two groups, those above the high box plot whisker,
    and those below the low box plot whisker, and if more than 25 then
    the intermediate values in a group are not listed
  more appropriate output when there is a frequency of zero on a
    by variable
  an explanatory note provided when computing row or column 
    proportions that result in divide by 0, which displays as NaN
    for "not a number"

label
  can assign a variable label to a variable as well as list the label, so
    labels can be created/modified without reading from an external file

corCFA
  lavaan code for the default maximum likelihood solution with the lavaan
    function cfa generated for the specified measurement model
  content of items by scale listed in the sorted order by loading
  parameter added, labels="only" only lists the variable labels with
    no analysis for a content analysis only
  model solution invisibly returned that includes the estimated parameters
    and the scale reliabilities plus residuals
  improved formatting of column displays

corEFA
  lavaan code generated for measurement model suggested by the EFA solution 

simCLT
  triangle package needed for antinormal distribution has been updated
    to R 3.0, so antinormal distribution restored (antinormal distribution
    has no values in the middle and most values at the extremes)


---------------
Bug Fixes 3.1
---------------

Merge, Recode, Subset, Transform
  variable labels that exist in the input data frame(s) are retained
    in the transformed data frame

BarChart, SummaryStats
  for more than 10 categories the proportions are correctly computed

Correlation, ScatterPlot
  correct variable labels listed

ScatterPlot
  method parameter used for purpose other than specifying spearman or
    kendall for correlation type, of which use is now flagged

corScree
  specified correlation matrix analyzed instead of just one named mycor

corEFA
  1 factor solution completes




>>>>>> Changes for lessR version 3.0 (2014-01-02)} <<<<<<

-------------
Updates 3.0
-------------

Subset
  new parameter: random 
    Specifies the number or proportion of data rows to retain, which
    replaces the dual use of the rows parameter to both perform
    this task and provide a direct specification of the rows of the
    data table to be included/excluded, so now the following work: 
      d <- Subset(c(1,4))  # retain only rows 1 and 4
      d <- Subset(-c(1,4)) # delete only rows 1 and 4

ttest
  new parameter: line.chart
    When set to TRUE, adds a line chart of the response variable
    for each group in the analysis
  aesthetics of the density curve output updated


---------------
Bug Fixes 3.0
---------------

ANOVA
  condition that lead to a warning for the means plot fixed

Correlation
  in the output, the correlation matrix object was always described
    as mycor regardless of the actual assigned name, this line of
    output is now deleted

Density
  missing data with specified bins now works

ttest
  density plot in gray scale if colors="gray.black"





>>>>>> Changes for lessR version 2.9.7 (2013-10-29)} <<<<<<

-------------
Updates 2.9.7
-------------

details
  add a brief version, details.brief, which only lists the table of
    variable names and any variable labels

ScatterPlot
  for 1-D scatter plot, to conform to standard R, rename option
     plot.method to method

Read
  relying upon the read.xls function from the gdata package, can
    read Excel files identified by the .xls or .xlsx filetype,
    both the data file and/or the labels file can be Excel files
  add a brief version, rd.brief, which calls the new details.brief
  provide an option to browse for the labels file, labels=""
  always display the full path of the data file and any label file


---------------
Bug Fixes 2.9.7
---------------

BarChart
  if a data frame analyzed, then a categorical variable with only 
    a single value would cause a fatal error, now the remaining
    variables are analyzed and a diagnostic displayed instead

Read
  labels files for Windows now properly specified

ScatterPlot
  for a plot with a categorical x-axis, additional parameters such as
    ylim now work correctly

corScree
  graph of "successive differences of eigenvalues" now properly labeled





>>>>>> Changes for lessR version 2.9.4 (2013-08-25)} <<<<<<

-------------
Updates 2.9.4
-------------

BarChart
  return the table of frequencies, so can assign to an object

BoxPlot
  subset of variables can be specified, e.g., bx(c(x,y,z))

CountAll
  parameters may now be added, such as bin.start for Histograms

Density
  test for normality done only if a normal curve is plotted

Histogram
  bin.end parameter added
  subset of variables can be specified, e.g., hs(c(x,y,z))

ttest
  to accommodate density plot of more data sets, bandwidth default
    changed from nrd to bcv
  two vector form of two-group t-test now accommodated from a data frame
    to permit a dependent-groups analysis from a data frame
  for a dependent-groups analysis, or paired t-test, a scatter plot of
    the two variables is produced with a diagonal line through the plot
    to indicate equality and the vertical distance from the line to each
    point displayed to indicate the extent of the change

ttestPower
  value of n on graph displayed as an integer or with decimal digits
    as appropriate

ScatterPlot
  for a scatter plot of two numeric variables, diag=TRUE places a diagonal 
    line through the plot with vertical lines from each point to the diagonal,
    primarily for plotting change in a dependent samples t-test
  removed x.start, x.end, y.start and y.end for bubble plots: use xlim, ylim

SummaryStats
  returns summary statistics for analysis of a single variable 
  subset of variables can be specified, e.g., ss(c(x,y,z))
  analysis of a data frame yields the default value of brief, which
    can be overridden in the function call


---------------
Bug Fixes 2.9.4
---------------

BarChart
  graceful termination if a bar chart is attempted with only 1 unique value

Density
  col.fill.nrm, normal curve fill, can set to transparent for blue color theme

Regression
  density lines in residuals density plot now appropriate color for
    black backgrounds

ScatterPlot
  xlim and ylim also applies to bubble plots, before they were ignored
  line plot by default even when intervals of successive values of a 
    sorted x are only equal to within 9 decimal digits 
  1-D plot displays outliers with same plot.method as regular points

Correlation
  name of first variable in bivariate correlation now displays correctly





>>>>>> Changes for lessR version 2.9.3 (2013-05-26)} <<<<<<

Note:  The Excel read functionality added in 2.9.2 is removed because it required
    Java, and this additional installation was adding too much complexity
    for users. To retain this functionality, do the following.

  > install.packages("xlsx")     # one time only
  > library(xlsx)                # for each R session to invoke the following
  > d <- read.xlsx(file.choose(), sheetIndex=1)

    This provides for a direct read of an Excel file by browsing for the file.
    To specify a specific path name or URL, replace file.choose() with the
    correct name in quotes.

    The only lost functionality if the above code is implemented is that variable 
    labels cannot be read with an Excel file. To provide for these labels first
    save the Excel file as a csv file.


-------------
Updates 2.9.3
-------------

LineChart
  a "zero" option is provided for center.line to pass the line through 0

simCLT
  the "antinormal" option is inactivated until the supporting triangle 
    package is updated


---------------
Bug Fixes 2.9.3
---------------

BarChart
  does not terminate when a table is specified as input






>>>>>> Changes for lessR version 2.9.2 (2013-05-08)} <<<<<<

-------------
Updates 2.9.2
-------------

Read
  tab-delimited text data file detected by default in addition to
   csv text data file
  Excel files now read and detected by default, including variable labels

Density
  for colors with a black background, density functions plotted with
    light colors

corRead
  abbreviation rad.cor no longer available, use rd.cor


---------------
Bug Fixes 2.9.2
---------------

Histogram
  rounding error in the computation of cumulative probabilities fixed




>>>>>> Changes for lessR version 2.9 (2013-03-11)} <<<<<<

-------------------
New Functions 2.9
-------------------

Nest
  compare a nested model to a full model with least-squares or logit fit

details
  obtain the details of a data frame, such as called from Read


-------------
Updates 2.9
-------------

a variable to be analyzed from the user's workspace is so noted

Read2
  renamed from rd2

Regression
  can return an object of class lm

Logit
  classification table added
  if only some forecasts shown, the middle range is for fitted values
    close to the threshold of 0.5
  collinearity analysis added for multiple predictor variables
  can return an object of class glm

ANOVA
  ANOVA tables now cleanly formatted
  residuals displayed as in Regression, by default first 20 sorted
  res.rows and res.sort options added, as in Regression

Histogram
  can return an object of class histogram

Density
  can return an object of class density

BoxPlot
  allow R graphics parameters to be passed, such as whiskcol, see ?bxp
  colors adjusted for gray and gray.black
  can return an object with standard boxplot components

SummaryStats
  if integers in input data then output to 2 decimal digits
  if more than 50 outliers, then just first and last 25 are displayed

set
  color white added
  quiet option now can be set, e.g., set(quiet=TRUE)
  brief option now can be set, e.g., set(brief=TRUE)


---------------
Bug Fixes 2.9
---------------

ANOVA
  brief form works correctly

Logit
  plot of fitted values and scatter plot produced consistently

BoxPlot
  numerical values on the correct axis for vertical and horiz orientation

Histogram
  situation in which largest value exceeded the largest bin fixed

set
  transparency properly initialized for default blue




>>>>>> Changes for lessR version 2.8 (2013-02-01)} <<<<<<

The keepers of CRAN have changed the rules. They no longer
allow a function to automatically direct output to a data table.
They have decided that users should always explicitly specify
the destination of the output file.

What that means for lessR is that any function that outputs a
data table now cannot automatically write that data table to
d or other chosen name. Instead you must now explicitly
assign the output data table name when reading or modifying data,
usually use  d  or  mycor. To do this, use the R assign
notation, <- , which assigns anything on the right side to whatever
is on the left side of the expression.
    > d <- Read()
    > d <- Transform(Y=X/12)     also Subset, Merge, Recode, Sort
    > mycor <- Correlation()
If you do not make this explicit assignment, the function still
works, but the output is dumped at the console instead of sent
to a stored data frame such as d to be available for later analysis.


Other generic changes:

To be consistent with R functions, the data frame option has been changed from dframe to data.  Usually this is not used as the default d is relied upon, but now specify other names with the data option.

Previously the brief option was used inconsistently.  For some functions it lead to a brief output, and for others it suppressed output.  It remains for functions that primarily send output to the console.  For graphics functions and data modification functions, now completely suppress output with quiet=TRUE.


-------------------
New Functions 2.8
-------------------

Merge
  merges two data frames either horizontally or vertically


-------------
Updates 2.8
-------------

default system setting
  n.cat, the maximum number of unique values of a variable to be treated as 
    a categorical variable by default, changed to 0, turned off by default

Recode, Sort, Subset, Transform
  now precede the function call with, for example:   d <-

Read
  now precede the function call with, for example:   d <-
  variable labels now incorporated directly into the data frame and
    are now read with the labels option
  rd is the abbreviation, though the older rad is still available
  lessR.data option re-specified as format="lessR"
  quiet option replaces brief

Subset
  holdout sample can no longer be created from with the function given the
    rule change from CRAN, but holdout=TRUE creates the code to copy and
    paste back into R to create the holdout sample

ttest
  for two group analysis from a formula, the separate data vectors
    are returned for later analysis (see the examples)
  graph for two group analysis now in gray scale for colors="gray"
  when input is summary stats, reported summary stats are to the 
    same level of precision as to what was input
  variable label, if present, appears on density graph
  standard R alternative option available for one-tailed tests
  paired=TRUE option available for dependent-groups t-test

ttestPower
  powercurve.t.test name removed in favor of ttestPower

ANOVA
  randomized blocks analysis displays the marginal and grand means
  two-way between groups analysis displays the cells size once instead of
    the same number for all cells

Regression
  standardization option available
  rgl package bug apparently fixed, so scatter.3d=TRUE is again available
    for models with two predictor variables
  singularity check added and solution terminated if so
  residuals vs fitted Values plot plotted with current color theme
  scatterplot of prediction intervals with current color theme

Correlation
  can use method="kendall" and method="spearman"
  graphics=TRUE to create a scatter plot matrix and heat map
  pdf=TRUE to create and write scatter plot matrix and heat map to pdf files

Density
  summary statistics reported by default
  quiet=FALSE replaces text.out=TRUE

Histogram
  quiet=FALSE replaces text.out=TRUE  

ScatterPlot
  one variable, method="jitter" option from R stripchart possible
  missing data removed to enable ellipse from car package
  the by variable need no longer be a factor
  fit.line applies to each level of a by variable
  for a by variable, width of plot adjusted for legend when saving to a pdf
  quiet=FALSE replaces text.out=TRUE

BoxPlot
  color of the box more vivid
  quiet=FALSE replaces text.out=TRUE

Logistic
  abbreviation is lr instead of older lgt

set
  default colors="blue" bar fill is lightsteelblue3 from lightsteelblue
  colors="sienna" and "gray.black" color themes added
  colors="dodgerblue" given a light gray background

BarChart
  reports the corresponding chi-square test
  count.names option name changed to the more meaningful count.levels
  quiet=FALSE replaces text.out=TRUE

PieChart
  for consistency with other functions, col.pieces changed to col.fill,
    the specified color of the regions of the pie chart
  quiet=FALSE replaces text.out=TRUE

SummaryStats
  only report summary statistics (chi-square test moved to BarChart)


---------------
Bug Fixes 2.8
---------------

ANOVA
  pdf=TRUE properly writes the graphs to the working directory

ttest
  graph for two group analysis shows the degrees of freedom in the title
  if missing a grouping variable data value, analysis still proceeds

BarChart
  ordered progressions of color with purple, sienna and dodgerblue work

Histogram
  col.ticks warning addressed and no longer generated
  text.out can now be set to FALSE

Density
  a perfectly symmetrical distribution properly plots as a density function

LineChart
  default area under the plotted line segments now fills to proper
    color according to the current color theme

ScatterPlot
  transparency for one and two variable plots correctly provided by default
  ellipse works correctly for non-regular plots such as bubble plots
  for kind option, bubble and sunflower can be now specified as documented
  sunflower plot has background and grid colors according to color theme
  show.n=TRUE works correctly for pairwise deletion for correlation matrix

Correlation
  properly accept variables in global environment

Regression
  prints residuals and forecasting errors when there is a factor predictor
  for categorical variables the results for all levels are displayed

set
  n.cat no longer set to 4 when set function called

Write
  if suffix .csv or .rda already exists, not added again to file name




>>>>>> Changes for lessR version 2.6 (2012-10-24)} <<<<<<


-------------
Updates 2.6
-------------

Graphics procedures
  Color themes were enhanced and the terminology for modifying individual
    colors in a specific graph or system-wide with the set function was
    standardized.  'fill' refers to the color of an interior region,
    either of a bar or a circle.  'stroke' refers to a line or outline,
    such as the border of a histogram bar or a plotted point. Also, to
    change a color theme is now only available with function set, as
    are references to transparent colors with trans.fill.bar and 
    trans.fill.pt.

set
  added an orange color theme, which has a black background instead
    of the usual light background, also added dodgerblue and purple
  revised green color theme
  added option ghost to provide transparent bars against a black background
    with no grid lines, which works well with colors such as orange and red
  colors option was getting too complex and was cluttering the options lists
    for the graphics functions, so color theme and transparency only
    available from the set function, but with more extensive options

Read
  default text output to console that describes the data is redesigned
  new parameter lessRdata allows direct reading of built-in data sets
  can read directly from built-in data sets with lessR.data= option

Write
  write any specified data frame, not just the default d
  specify any file name or rely upon the default
  by default write row IDs as part of the written csv file
  the dframe option moved to the end of the parameter list to be
    consistent with Read

Subset
  abbreviation locate added to emphasize locating cases without creating
    a new data frame, where save.dframe is automatically set to FALSE
  can subset on row.names
  criterion for selecting rows, rows, can be an integer or proportion,
    to indicate the number of rows to randomly extract and also to create
    a hold out sample

Recode
  just data for the variables to be recoded are shown before the recode, 
    and just the recoded and any new variables shown after the recode
  a recode is not allowed to be applied to a factor because doing so
    converts the factor to character strings (use factor function instead)

Transform
  transformed data is shown only for variables that have been transformed

Sort
  default saves the sorted data frame written over the input data frame
    without needing to explicitly assign the result to a data frame
  the keep=FALSE option allows the sorted data frame to be written to
    another data frame with the R assignment statement
  random option added to randomly shuffle the rows of data

Help
  the argument for a specific help page no longer needs to be enclosed
    in quotes  
  capitalization of the argument for a specific help page is irrelevant

ANOVA
  randomized block design supported (in addition to one and two factor
    between groups designs)
  fitted plot and data plotted for randomized block design
  residuals provided 
  effect sizes provided
  graphs may be saved to pdf files with pdf=TRUE
  one-way cell mean plot works with current color theme
  HSD analysis for two-way models, between groups and randomized blocks
  marginal means provided for two-way models

Regression
  scatterplot matrix incorporates the color theme
  display of prediction intervals includes interval width
  decimal digits uniformly applied across the text output

Logit
  scatterplot matrix added when there are multiple predictor variables

ttest
  option for saving the graphic of the two density curves to a pdf,
    consistent with other lessR functions for graphics
  add a show.title option to suppress the title over the graph
  Cohen's d effect size index added to one-group t-test
  density plot with Cohen's d, mean and hypothesized mean

ScatterPlot
  for one variable, dot plot, gray scale outliers displayed in squares
    and diamonds, for potential and actual outliers, respectively

Histogram
  trans.bars option available, analogous to trans.pts for scatter plots

LineChart
  option col.border added to specify the border color of the filled
    polygon under the plotted lines, including the value of "transparent"

BoxPlot
  dotplot option changed to add.points to be consistent with the call
    to the ScatterPlot function for one variable, i.e., a 1-D scatter plot

corCFA
  sum of squares and average residual for each item and total available
  the number of default iterations for communality estimates increased
    from 15 to 25
  an abbreviation called scales added to retain 1's in the diagonal for
    component analysis, that is, the observed scale scores

corEFA
  items by default sorted by their highest factor loading, with an
    option provided to not do this
  min.load option changed to min.loading and this applies to the
    output of the EFA as well as the constructed model for the CFA
  n.fact argument changed to n.factors

data files
  the name of each included data file begins with "data" instead of "dat"

prob.tcut
  renamed from qnt.t, t-cutoff probability function with t and normal curves



---------------
Bug Fixes 2.6
---------------

Subset, Transform, Sort
  when dframe not saved because save.dframe set to FALSE, dframe 
    properly is assigned to a new data frame via an assignment statement

PieChart
  colors option works correctly

BarChart
  changes to background color and grid with colors="gray" work correctly
  frequency table displayed when prop=TRUE

LineChart
  color theme now applied to fill color under plotted polygon

ttest
  standard deviation on graph for second group reported correctly





>>>>>> Changes for lessR version 2.5 (2012-08-09)} <<<<<<


-------------------
New Functions 2.5
-------------------

Sort
  sorts the rows of a data frame by the values of specified variables for
    both numeric variables as well as factors

Transform
  a modified version of the standard R transform function, but by default
    saves the revised data frame to the input data frame and provides
    feedback and information regarding the transformation(s)

Subset
  a modified version of the standard R subset function, but by default
    saves the revised data frame to the input data frame and provides
    feedback and information regarding the changes to the data frame

Logit
  logit analysis, a wrapper for the standard R glm function with
    family=binomial plus related functions such as summary and predict


-------------
Updates 2.5
-------------

corCFA, corReflect, corReorder
  variables are now specified by their names instead of by their ordinal
    position in the correlation matrix

corEFA
  to match the change in specifying variables in corCFA, the derived
    confirmatory model is now written in terms of variable names

corScree
  on the graph of the differences of successive eigenvalues, a horizontal
    line is drawn to better highlight the "scree"

Correlation
  now can provide a list of variables from the input data frame instead
    of having to first separately create the subset data frame 
  now non-numeric variables are now automatically deleted from a submitted
    data frame or variable list with the analysis proceeding

Recode
  a list of variables instead of just one variable may now be recoded
  missing data entries may now be recoded to valid values
  specified valid values may now be recoded to missing values

ScatterPlot
  original function Plot, abbreviated plt, was based on R function plot, 
    which did a scatter plot of two variables and also also did a line chart
    for one variable, now only 1 and 2 dimensional scatter plots are done, 
    so function renamed accordingly, where a 1-D scatter plot is a dot plot,
    though Plot is still available as a name

Help
  each help page can now be invoked with a variety of key words, which
    usually include the full and abbreviated names of each function
    described on that help page


---------------
Bug Fixes 2.5
---------------

SummaryStats
  now recognizes n.cat to treat numeric variables as categorical if the
    number of unique values is less than or equal to n.cat

corCFA
  when default sort option on, sometimes items were not sorted properly

set
  the transparency level of plotted points in ScatterPlot now works





>>>>>> Changes for lessR version 2.4 (2012-07-21)} <<<<<<


-------------------
New Functions 2.4
-------------------

Recode
  recode individual values of an integer or factor variable

The following new functions work with a correlation matrix, named
mycor by default, instead of the data matrix from which the correlations 
are computed. Each function that outputs correlations also generates a
heat map of the output matrix.

corCFA
  confirmatory factor analysis and item analysis for multiple indicator
  measurement models from an input correlation matrix

corEFA
  exploratory factor analysis based on R factanal function, though also
  provides for a multiple indicator measurement model based on the
  exploratory analysis and the corCFA code for which to analyze the model

corList
  list the ordinal position of each variable in the input correlation matrix
  to facilitate using the other correlational routines

corProp
  calculate proportionality coefficients from an input correlation matrix,
  used to identify items that are indicators of the same factor

corRead
  read an input correlation, or other square, matrix

corReflect
  reflect specified variables in an input correlation matrix

corReorder
  re-order the specified variables in the input correlation matrix

corScree
  eigenvalue plot and plot of differences of successive eigenvalues to help
  determine the number of factors


-------------
Updates 2.4
-------------

System wide
  Variable labels when applied to axis labels on a graph are now truncated
    to 50 characters for y-axis and 45 characters for x-axis to fit
  All graphic files can now be saved from the call to the graphic function
    as preceding the function call with an R pdf statement does not work
    due to the customized graphics system that allows the Help window
    to persist across analyses
  Cutoff value to interpret a numeric variable as categorical now called
    n.cat instead of n.cut, and is implemented system wide with the 
    set function

Correlation
  minimum default number of digits in output correlation matrix is 2
  computed correlation matrix automatically written to mycor
  missing data choices made explicit with parameter miss, pairwise is default
  cell-wise sample size reported for pairwise deletion
  effective sample size for all cells reported for listwise deletion
  heat map added when a correlation matrix is computed

Plot
  provide for a by variable, a grouping variable, for which the points
    are plotted in a different color and/or shape for each value of by

SummaryStats
  IQR added to full version

BarChart
  legend placement option for right margin added to the standard R legend
    locations and is now the default, legend.position="right.margin"
  legend in right margin accommodates variable labels
  for displayed cross-tabulation table, variable names instead of 
     variable labels used
  for count.names option, no longer needed to place the data frame name
    and a $ in front of the specified variable name
  text.out option added so can be set to FALSE
  when applied to a data frame, individual graphs written to individual files

Histogram
  text.out option added so can be set to FALSE
  when applied to a data frame, individual graphs written to individual files

BoxPlot
  text.out option added so can be set to FALSE
  when applied to a data frame, individual graphs written to individual files

ttest
  graph option added, if FALSE then no graph is produced for two groups

LineChart
  changed name from RunChart to better reflect its more general meaning

Deprecated function names removed
  color.barchart, color.boxplot, color.density, color.hist

Deprecated function names renamed
  sim.CLT to simCLT, sim.CImean to simCImean,
  sim.flips to simFlips, sim.means to simMeans


---------------
Bug Fixes 2.4
---------------

Summary Statistics
  labels for the two variables in a cross-tab no longer switched

to
  remove debug print statement

ttest
  extra null graphic window no longer generated for two groups analysis

BarChart
  left margin on horizontal bar chart was sometimes too large
  color theme for a single variable now properly displays





>>>>>> Changes for lessR version 2.3 (2012-06-10)} <<<<<<

------------
Overview 2.3
------------

Naming Conventions
------------------
All data analysis functions now have two names, a longer, more descriptive name, that
involves uppercase letters, such as Summary Stats, and a short abbreviation, here ss.
Either version is equivalent. The purpose of the uppercase letters is to distinguish
lessR functions from the standard R functions with similar names.  When appropriate,
functions can also have an abbreviation such as brief to indicate a briefer form of
output, here ss.brief.

Color Themes
------------
Using the new set function, the colors options sets the system wide color theme.
The default is "blue" and several other colors are available, including gray scale 
with "gray". The colors option may also applied to any one specific graphic
function call to set the color theme just for that one resulting graph.

Transparency for plotting individual points with Plot is also available with the 
trans.pts option, from 0 to 1, with a 0 being opaque and a 1 being fully 
transparent. The trans.pts option may be set with the set function for all
subsequent analyses, or it may be set for any one specific call to Plot.

Direct Reference of Variable Names (from 2.2)
----------------------------------
lessR defaults the name of the data frame with data read from the Read or rad 
function with d. Now this convention is leveraged by dropping the need for the
R attach function, or by having to include the data frame name and a $ in front of
the variable name, or using the with function. Instead, for each specified variable
name, lessR searches the user's workspace, the global environment, as well as the
data frame d, or the specified data frame name, for the relevant variable.

Variable Labels (from 2.2)
---------------
lessR functions now can access variable labels, which will replace the variable 
names on the axis labels for graphic output, and be displayed adjacent to the 
variable names on text output.  Use the labels function to access the variable
labels for standard R functions.  See help(Read) for directions on how to enter
the variable labels.

Improved Appearance of Graphs
-----------------------------
In addition to the new color themes, the appearance of the graphs has been changed
to print the values along each scale of an axis is a smaller font and a shade of
gray instead of black.


-----------------
New Functions 2.3
-----------------

Model, model
  Function for a linear analysis, which automatically calls the relevant function -- 
    ttest, ANOVA or Regression -- and therefore replaces those functions from the
    user's perspective.

set
  Created as a wrapper for options(colors="xxx") added for graphics routines to
   specify a color theme.
      
to
  Created to generate variable name lists with sequential numbers when reading
    data into R such as from a csv data file.


-----------
Updates 2.3
-----------
Help, hlp
  updated help window opens when lessR is loaded

Read, rad
  Add option for reading native R data files
  SuppressWarnings to avoid warning message on read.csv for Excel csv files with no
    last <cr>
  SuppressWarnings on SPSS files to avoid "Unrecognized record type 7"

Write, wrt
  Add option for writing native R data files
  Automatically add a file type, either .csv or .rda

ttest, tt
  Also do analysis of not assuming equal variances.
  Set extra decimal digit for analysis from stats (already set from data)
  By default, at least two decimal digits
  Added consistent formatting to numerical output according to digits.d
  Two-group density graph has density scaling removed from y-axis
  Two-group density graph has smaller font sizes and margin adjustment

BarChart, bc
  Brief stat output now the default, bc.brief removed
  Add error condition of not having col.bars and colors both activated
  Add colors="gray" option and bc.gray
  Display tick marks and tick labels in dark gray

Histogram, hst
  Add vertical grid in addition to existing horizontal grid
  Add colors="gray" option and hst.gray
  Display tick marks and tick labels in dark gray

DotPlot, dp
  Add colors="gray" option and dots.gray
  Display tick marks and tick labels in dark gray

Density, dens
  Remove horizontal grid, leaving no grid
  Add colors="gray" option and dens.gray
  Display tick marks and tick labels in dark gray

Plot, plt
  Add colors="gray" option and plt.gray expression
  Display tick marks and tick labels in dark gray
  Add ncut to treat x as a factor if too few unique data values
  When x is a factor, now do summary stats of y by each level of x
  Run chart now lists n and n.missing
  Scatterplot matrix and correlation matrix added for a data frame

Regression, reg
  3D scatterplot optional for two predictor variables instead of required
  The colors setting applies to reg graphs

BoxPlot, bx
  Consistent formatting of text output with default decimal digits

Correlation, cr
  Correlation routine pulled from plt and made its own function
  The version cr.brief added
  Correlation matrix of a data frame added

RunChart, rc
  old access was Plot with one variable, which now produces a dot plot

prob.norm
  now returns the probability in the console like R pnorm function

qnt.t
  renamed from prob.t as it is the quantile that is returned
  now returns the quantile in the console like R qt function


-------------
Bug Fixes 2.3
-------------

system wide
  a variable named with the name of an R function is now permissible

ttest, tt
  Analysis from summary statistics does not need a d data frame 
           to exist prior to the function call
  Variable labels no longer switched on response and grouping variables
  Labels now work with one group analysis
  Properly align group1 and group2 output to the user's workspace
           with the correct group

Plot, plt
  Run plot failed if missing data
  Plot with factor on x-axis failed plot of means if missing data
  If missing data, do not try ellipse which fails
  For bubble plot, x-axis now has proper scale

Summary Statistics, ss
  The null graphic window no longer opened

BoxPlot, bx
  When doing a dot plot, colors did not transfer from bx






>>>>>> Changes for lessR version 2.2 (2012-03-28)} <<<<<<


-----------------
New Functions 2.2
-----------------


sim.CLT 
  Simulation for Central Limit Theorem

sim.flips 
  Simulation of coin flips

sim.CImean
  Simulation of confidence interval

sim.means 
  Simulation of repeated sampling of means

prob.t 
  Probabilities of t-distribution


-----------
Updates 2.2
-----------

Note:  The following long form names are not valid as function calls until Version 2.3.

graphics routines
  Font for scale values along each axis smaller and in a dark gray

ttest, tt
  Rewrite to allow one or two groups, data or summary stats
  Allow missing data
  Restore graphic parameters so top margin of graphics window not too large
  tt.brief option added

BarChart, bc
  Count.names option for reading counts directly from a data file with counts
  Smaller font for legend and no legend border to better display
  Smaller font for axis values
  For horizontal plots, horizontal labels and accommodate space in left margin
  bc.brief added, brief=FALSE is new default for bc

Histogram, hst
  Smaller font for scale

Plot, plt
  Smaller font for legend and no legend border for 2 variables to better display
  Provide covariance coefficient

Summary Statistics, ss
  ss.brief added

Correlation, cr
  Provide covariance coefficient

Density, dens [now den in 2.3]
  Provide densities on vertical axis as an option instead of a requirement

Read, rad 
  Read spss (.sav) files in addition to csv data files
  For rad.both, have labels display correctly

prob.norm [normal curve probabilities]
  Only give normal densities on vertical axis as an option
  Add second x axis, z-scores
  Make vertical, density, axis as an option
  Scale axis labels to .9, add mag option

prob.znorm [normal curve display with z-scores]
  Default y-axis to null, add as an option
  Add z-values as a default
  Scale x-axis according to standard deviations
  Scale axis labels to .9, add mag (magnify) option

stats.t.test
  Removed, incorporated into ttest which now processes data from 
    summary statistics or the data


-------------
Bug Fixes 2.2
-------------

Regression, reg
   If residual is 0, Nan's lead to missing data no longer causes 
     Cook's distance function, and therefore the entire function, to fail






>>>>>> Changes for lessR version 2.1 (2012-02-08)} <<<<<<


-----------------
New Functions 2.1
-----------------

dots  [in 2.3 rename to DotPlot, dp]
  created the function

pieplot [in 2.3 rename to PieChart, pc]
  created the function


-----------
Updates 2.1 
-----------

package
  add citation
  all lessR functions that read data have attach requirement removed
  relevant lessR functions have automatic use of variable labels
  variable labels function label

rad   [in 2.3 also named Read]
  display name of file read at the beginning of the output only if rad()
  default is now to not attach d
  add read labels options with rad.labels and rad.both
  add max.lines options and display full data/labels when applicable
  convert display option to brief option, add function

reg  [in 2.3 also named Regression]
  add error check for no data frame, which is required
  for Background, specify number of obs retained for analysis
  add references
  add variable labels to Background section where variables are listed
  add reg.brief and reg.explain methods
  reformat Basic Analysis output to print all values individually
  if a non-numeric variable in model, then do not attempt scatterplot matrix
  if a non-numeric variable in model, then no scatter.3d plot

plt  [in 2.3 also named Plot]
  in title, use actual variable names instead of "x and y"
  loess fit line replaces lowess, along with access to loess span parameter
  use dates from an existing time series
  add missing data count
  put error traps for calling with the wrong data types

barchart  [in 2.3 rename to BarChart, bc]
  reformat output to much more compact
  for UseMethod, evaluate class of 1st attribute only to avoid a warning
  add a y-axis label
  get border option to work and change name to col.border
  properly switch axis labels if horiz=TRUE
  add warning message for beside option off with only a single variable
  add warning message if addtop set for a horizontal bar graph
  make chisq the default, and reformat output
  put the variable names on the tables for row and column proportions
  re-scale bar width for 2, 3 or 4 bars, from 1 var or stacked 2 var
  get vivid option to work for gradient applied to ordinal data
  for vertical graphs of two vars, make legend horizontal with addtop room
  for data frame, numeric data types of few unique values treated as categorical
  for data frame, add dev.off() when finished with graphs
  enhanced the color palettes with R palettes of rainbow, heat and terrain
  make stacked chart for two variables the default

smooth  [in 2.3 rename to Density, den]
  add bw parameter
  make no density axis the default, but add y.axis to include if desired
  add normality test
  allow for missing data
  change col.hist to col.bars
  get color of the plotted curves working

histogram  [in 2.3 rename to Histogram, hst] 
  move Number of Bins output next to freq dist, add Bin Width
  summary statistics and label now with describe.numeric
  scientific notation turned off for histogram plot
  col and border options renamed to col.bars and col.border
  summary stats now provided
  for data frame, numeric data types of few unique values treated as categorical
  for error message regarding bin range, turn off scientific notation

boxp   [in 2.3 rename to BoxPlot, bp] 
  add values of outliers to text output
  adjust axis labels for vertical box plot
  provide for default colored background and grid lines

describe [in 2.3 rename to SummaryStats, ss]
  formula input changed to by= option
  output reformatted to much more compact, and extended
  outlier detection added to description of numerical variables
  if too many values, then just report counts
  if all values unique, just report the values and a note as an ID field
  for numeric, if digits.d > 10, output size changed to 4 with prompt to override
  for data frame, numeric data types of few unique values treated as categorical
  add skewness, kurtosis
  add a brief=TRUE option, which works for both numeric and categorical variables

smd.t.test  [in 2.3 rename ttest,tt]
  add brief option and function

stats.t.test [in 2.3 incorporated into ttest]
  add one-sample option
  by default resolve number of digits from precision of entered stats

help.me  [in 2.3 now named Help, hlp]
  update color.hist [in 2.3 Histogram, hst] description


-------------
Bug Fixes 2.1
-------------

plt  [in 2.3 also named Plot]
  missing data caused an error in bubble plot

reg  [in 2.3 also named Regression]
   allow missing data

